  	page	,132
;PACTERM  KPC/UTU-XT VERS 1.03  5/20/87
;PACTERM  (c)Copyright Kantronics Inc. 1987,  all rights reserved.
;
code	segment
	assume	cs:code,ds:code,es:code
	org	05ch
fcb	db	?
	org	0100h	;setup for .COM file
begin:	jmp	short start
;
F1	equ	59
F2	equ	60
F3	equ	61
F4	equ	62
F5	equ	63
F6	equ	64
F7	equ	65
F8	equ	66
F9	equ	67
F10	equ	68
ALTB	equ	48
ALTC	equ	46
ALTE	equ	18
ALTF	equ	33
ALTH	equ	35
ALTI	equ	23
ALTP	equ	25
ALTR	equ	19
ALTS	equ	31
ALTT	equ	20
;ALTX	equ	45
;
bufctl	db 	ALTB
clrhol	db 	ALTC
retrck	db 	ALTE
filxmk	db 	ALTF
retrcv	db 	01dh
filxmt	db 	0fah
print	db 	ALTP
rcv	db 	ALTR
spdchg	db 	ALTS
xmit	db 	ALTT
;exitam	db 	ALTX
invert	db 	ALTI
shift	db 	ALTH
help	db 	F1
savebu	db 	F2
kpckey	db 	F3
typeah	db 	F5
rtstog	db 	F6
comprk	db 	F7
baudk	db 	F8
exicmd	db 	F9
exidos	db 	F10
;
split	equ	7
lines	equ	25
boot	equ	0
makef	equ	016h
wrtf	equ	015h
closf	equ	010h
readf	equ	014h
openf	equ	0fh
int0	equ	20h	;intr. port 0 (EOI)
intmsk	equ	21h	;intr. port 1--intr. mask
rsbas1	equ	3f8h	;comm port1 reg. base
rsbas2	equ	2f8h	;comm port2 reg. base
intms1	equ	0efh	;port1 intr. mask--irq4
intms2	equ	0f7h	;port2 intr. mask--irq3
ivect1	equ	0ch	;intr. vector port1
ivect2	equ	0bh	;intr. vector port2
pbnful	equ	248
rsnful	equ	248
imask	db	0ffh	;intr. mask
	even
rsbase	dw	3f8h	;comm port reg. base
rscnt	dw	0	;rs buffer char count
pbcnt	dw	0
;
scrwd	dw	0
point	dw	?
hbufp	dw	hbuf
prp	dw	?
prq	dw	?
tbp	dw	?
tbq	dw	?
eoram	dw	?
tcur	dw	?
rcur	dw	?
rsp	dw	?
rsq	dw	?
ibp	dw	?
kpccom	dw	0
utucom	dw	0
kpcbau	dw	4
utubau	dw	4
sc0cur	dw	0
sc1cur	dw	0
;
canlch	db	18h
comch	db	3
delch	db	8
passch	db	16h
starch	db	11h
stopch	db	13h
xonch	db	11h
xoffch	db	13h
;
ctrlkey db	?
keycode db	?
incena	db	0
prtena	db	0ffh
rtsena	db	0ffh
rtssav	db	0
ctssav	db	0
bufful	db	0
temp	db	?
slf	db	0ffh
vidatt	db	?
vidmod	db	?
binflg	db	0
autocr	db	0
autolf	db	0
autocnt db	072h
chrbuf	db	0dh
charcnt db	?
dswch	db	0
tswch	db	0
pswch	db	0
bswch	db	0
kpcsw	db	0
fflag	db	?
;
start:	mov	ax,sp	;set aside 256 bytes for stack
	sub	ax,0100h
	mov	eoram,ax
	mov	ah,15	;save screen width in scrwd
	int	010h
	mov	byte ptr scrwd,ah
	mov	vidmod,al
	mov	ah,8	;get video attribute
	xor	bh,bh	;page 0
	int	10h
	mov	vidatt,ah
	call	actsc1
	call	blkscr		;blank and home screen 1
	mov	si,offset helpmsg
	call	wrtmsg		;set up help menu
	call	actsc0
	call	upport
	call	helpdi
reset:	call	home
	mov	dx,256*(lines-2)
	call	line
	mov	dx,256*(lines-split)
	call	line
	mov	bx,1
	call	staban
	mov	dx,256*(lines-3)
	mov	tcur,dx
	call	pos
	mov	rcur,256*(lines-split-1)
	mov	tswch,0ffh
	xor	ax,ax
	mov	ctrlkey,al
	mov	keycode,al
	mov	dswch,al
	mov	pswch,al
	mov	bswch,al
	mov	fflag,al
	mov	rtssav,al
	mov	ctssav,al
	mov	tbp,ax
	mov	tbq,ax
;	mov	rsp,ax
;	mov	rsq,ax
	mov	prp,ax
	mov	prq,ax
	mov	ibp,ax
;	mov	rscnt,ax
	mov	pbcnt,ax
;
;main loop for transmit/receive
;
main:	call	getkey	;process keyboard
	jz	mainb 
	cmp	al,013h
	jz	mainb 
	cmp	al,011h
	jz	mainb
	mov	di,tbp	;put key in transmit buffer
	mov	tbuf[di],al	;(no checking done for buffer full)
	inc	di
	and	di,tbufsz-1
	mov	tbp,di
	cmp	al,8
	jz	main2	;jump if delete
	cmp	al,0ah	;display character on screen
	jz	mainb	;ignore LFs
	cmp	al,0dh	;scroll if CR
	jz	main1
main0:	call	outch	;display char
	inc	tcur
	mov	ax,tcur ;if cursur at end of screen, then scroll
	cmp	al,byte ptr scrwd
	jnz	mainb
main1:	mov	ax,0601h	;scroll transmit section of screen
	mov	bh,7
	mov	cx,256*(lines-split+1)
	mov	dx,scrwd
	add	dx,256*(lines-3)-1
	int	010h
	mov	dx,256*(lines-3)	;reposition transmit cursur
	mov	tcur,dx
	call	pos
	jmp	short mainb
main2:	cmp	tcur,256*(lines-3)	;cannot delete if cursur
	jz	mainb	;		 is at beginning of line
	call	outch	;remove character from screen
	dec	tcur
	mov	al,' '
	call	outch
	mov	al,8
	call	outch
;
mainb:	call	getrs	;process characters received from UTU
	jz	maincl
	mov	temp,al
	cmp	pswch,0
	je	mainbb
	mov	bx,prp	;put char into print buffer
	mov	byte ptr pbuf+[bx],al
	inc	bl
	mov	prp,bx
	mov	cx,pbcnt
	inc	cx	;increment char count
	mov	pbcnt,cx
	cmp	cx,pbnful
	jbe	mainbb
	mov	bufful,0ffh
	mov	dx,rsbase
	add	dx,4	;address mcr
	mov	al,9	;disable rts and leave dtr and out2 set
	out	dx,al
	mov	al,temp
	mov	prtena,0	;disable print enable
mainbb: cmp	bswch,0 ;if enabled, put char into holding buffer
	jz	mainbz
	mov	di,hbufp	;if holding buffer is full,disable it
	cmp	di,eoram
	jnz	mainba
	mov	ah,bufctl
	mov	keycode,ah	;ALTB
	jmp	short mainbz
maincl: jmp	mainc
mainba: mov	byte ptr [di],al
	inc	hbufp
mainbz: cmp	al,0ah	;display char in rcv section of screen
	jz	maincl	;ignore LFs
	cmp	al,0dh
	jz	mainb0	;if CR, then scroll
	cmp	al,retrcv
	jnz	maibz
	xor	al,al
	mov	dswch,al ;turn transmit enable off if retrcv char
	mov	bx,3
	cmp	dswch,0
	call	staban
	mov	al,3
	call	out232
	mov	al,'R'
	call	out232
	jmp	mainc
maibz:	push	ax
	mov	dx,rcur ;display char at rcv cursur position
	call	pos
	pop	ax
	xor	bx,bx
	cmp	al,8
	jne	maib0
	dec	rcur
	jmp	short mainb1
maib0:	cmp	al,9
	jz	maib00
	cmp	al,7
	jnz	maiby
	mov	ah,14
	int	010h
	jmp	short mainb1
maiby:	xor	cx,cx
	inc	cx
	jmp	short maib02
maib00:	dec	al
	mov	ah,byte ptr rcur
	inc	ah
	and	ah,7
	sub	al,ah	;8-(rcurcol mod 8)
	and	ax,7
	inc	ax
	mov	cx,ax
maib01:	mov	al,' '
maib02:	push	cx
	mov	ah,10
	mov	cx,1
	int	010h	;write w/o scroll
	inc	rcur
	mov	ax,rcur ;if at end of line,then scroll
	cmp	al,byte ptr scrwd
	jae	mainb0
	pop	cx
	loop	maib01
	jmp	short mainb1
mainb0: mov	rcur,256*(lines-split-1)	;scroll rcv section of display
	mov	ax,0601h
	mov	bh,7
	xor	cx,cx
	mov	dx,scrwd
	add	dx,256*(lines-split-1)-1
	int	010h
mainb1: mov	dx,tcur ;reposition cursur in transmit section
	call	pos
;
mainc:	mov	al,ctrlkey	;process keyboard commands
	mov	ah,keycode
	mov	ctrlkey,0
	mov	keycode,0
	and	al,al
	jnz	maindk
	cmp	ah,exidos
	jne	mainc0
godos:	call	clsfil	;if F10, close file,
	cmp	kpcsw,0
	jne	goedos
	mov	al,'D'	;xmit Disconnect if KPC,
	call	out232
	mov	al,0dh
	call	out232
goedos: call	bottom	;go to bottom of screen, and
	mov	ah,0
	int	021h	; return to DOS
mainc0: cmp	ah,exicmd   ;F9-return to CMD: loop
	jnz	mainc1
	call	clsfil
	jmp	reset
maindk:	jmp	maind
mainc1: cmp	ah,rcv ;ALTR
	jnz	mainc2
	cmp	kpcsw,0
	je	manc1a
	mov	al,3
	call	out232
	mov	al,'R'	;transmit ^C R to UTU-XT
	call	out232
manc1a: xor	al,al
	mov	dswch,al
	mov	tswch,al
	mov	bx,3
	cmp	dswch,0
	call	staban
	mov	bx,5
	cmp	tswch,0
	jmp	mainc7a
mainc2: cmp	ah,xmit ;ALTT
	jnz	mainc3
	cmp	kpcsw,0
	je	manc2a
	mov	al,3
	call	out232
	mov	al,'T'	;transmit ^C T to UTU-XT
	call	out232
manc2a: mov	al,0ffh
	mov	dswch,al
	mov	tswch,al
	mov	chrbuf,0dh
	mov	bx,3
	cmp	dswch,0
	call	staban
	mov	bx,5
	cmp	tswch,0
	jmp	mainc7a
maindl: jmp	maind
mainc3: cmp	kpcsw,0
	je	mainc5
	cmp	ah,spdchg ;ALTS
	jnz	mainc5
	cmp	dswch,0 ;speed change only in rcv mode for cw/rtty/ascii
	jnz	maindl
mainc3a:	call	getchar
	cmp	al,'0'
	jb	mainc3a
	cmp	al,'9'
	ja	mainc3a
	mov	spbuf,al
	mov	al,3   
	call	out232	;send ^C #(0-9) to change speeds in cw/rtty/ascii
	mov	al,spbuf
	call	out232
	jmp	reset
mainc5: cmp	ah,bufctl    ;ALTB enables/disables holding buffer
	jnz	mainc6
	mov	bx,7
	not	bswch
	cmp	bswch,0
	jmp	short mainc7a
mainc6: cmp	ah,clrhol    ;ALTC clears holding buffer
	jnz	mainc7
	mov	hbufp,offset hbuf
	jmp	short maindl
mainc7: cmp	ah,print  ;ALTP enables/disables printer
	jnz	mainc8
	mov	bx,6
	xor	ax,ax
	mov	prp,ax
	mov	prq,ax
	not	pswch
	cmp	pswch,0
mainc7a:	call	staban
	jmp	maind
mainc8: cmp	kpcsw,0
	je	maincb
;	cmp	ah,exitam ;ALTX to resync utu menu with utu-term
;	jnz	mainc9
;	call	resetx
;	jmp	reset
mainc9: cmp	ah,invert ;ALTI
	jnz	mainca
	mov	al,3	;to transmit, send ^C I to UTU-XT
	call	out232
	mov	al,'I'
	call	out232
	jmp	short maind
mainca: cmp	ah,shift ;ALTH
	jnz	maincb
	mov	al,3	;to transmit, send ^C S to UTU-XT
	call	out232
	mov	al,'S'
	call	out232
	jmp	short maind
maincb: cmp	ah,help 	;F1-display help message on screen 1
	jnz	maincc
	call	helpdi
	jmp	short maind
maincc: cmp	ah,savebu	;F2-save buffer
	jnz	maincd
	jmp	savbuf
maincd: cmp	ah,typeah	;F5-toggle type ahead	
	jnz	maince
	mov	bx,5
	not	tswch
	cmp	tswch,0
	jmp	short mainc7a
maince: cmp	ah,rtstog	;F6-toggle rts	 
	jnz	maind
	mov	bx,4
	not	rtsena
	cmp	rtsena,0
	jmp	mainc7a
;
maind:	call	monxts
	cmp	bufful,0ffh
	jne	maind0	;don't transmit if rs or pb buffer full
	cmp	ctssav,0
	jne	maind0
	jmp	maine
maind0:	cmp	tswch,0 ;process transmit buffer
	jz	maine	;jump if receive
	call	gettb
	jz	maine	;jump if transmit buffer empty
	cmp	kpcsw,0
	jne	maind1
	call	out232	;transmit char to KPC
	jmp	short maine
maind1:	cmp	al,retrcv
	jnz	maind2
	push	ax
	xor	al,al
	mov	tswch,al
	mov	bx,5
	cmp	tswch,0
	call	staban
	pop	ax
maind2:	call	out23c	;transmit char to UTU-XT
;
maine:	cmp	pswch,0 ;process printer buffer
	jz	mainl	;jump if printer not enabled
	mov	bx,prq
	cmp	pbcnt,0
	jz	mainm	;jump if printer buffer empty
	mov	ah,2
	xor	dx,dx
	int	017h
	and	ah,080h
	jz	mainl	;jump if printer busy
	mov	al,pbuf+[bx]	;get character from printer buffer
	inc	bl
	mov	prq,bx
	push	cx
	mov	cx,pbcnt
	dec	cx
	mov	pbcnt,cx
	pop	cx
	xor	ah,ah	;and print it
	xor	dx,dx
	int	017h
mainl:	jmp	main
mainm:	mov	prtena,0ffh	;set printer enable
	mov	bufful,0
	call	setrts
	jmp	short mainl
;
;
savbuf: call	home	;save holding buffer to disk
	cmp	hbufp,offset hbuf
	jnz	savb0
	mov	dx,offset mess9 ;error message if holding buffer empty
	mov	ah,9
	int	021h
	call	getchar
	jmp	resetl
savb0:	mov	dx,offset mess4 ;get filename
	mov	ah,9
	int	021h
	mov	dx,offset filebuf
	mov	byte ptr filebuf,13
	mov	ah,10
	int	021h
	mov	di,offset fcb
	mov	si,offset filebuf+2
	mov	ax,02900h	;verify filename as proper
	int	021h
	and	al,al
	jnz	resetl	;jump if improper or ambiguous filename
	mov	binflg,al
	cmp	fcb+9,'B'
	jnz	savb2
	cmp	fcb+10,'I'
	jnz	savb2
	cmp	fcb+11,'N'
	jnz	savb2
	dec	binflg	;set binary flag if .BIN extension
savb2:	mov	dx,offset fcb
	mov	ah,makef	;create file
	int	021h
	and	al,al
	jnz	resetl
	mov	fcb+32,al	;initialize buffer pointers
	mov	si,offset hbuf
	mov	di,boot+080h
	mov	bl,0
savb1:	cmp	si,hbufp
	jz	savb9	;jump if end of buffer
	mov	al,[si] ;get char from buffer
	cmp	binflg,0
	jnz	savb6	;jump if binary file (.BIN)
	cmp	al,' '
	jae	savb4
	cmp	al,9
	je	savb4
	cmp	al,0dh
	jnz	savb8
savb3:	mov	al,0dh
	call	writeb
	mov	bl,0
	mov	al,0ah
savb4:	call	writeb
	inc	bx
	cmp	al,' '
	mov	al,75
	jz	savb5
	mov	al,80
savb5:	cmp	al,bl
	jb	savb3
savb8:	inc	si
	jmp	short savb1
savb6:	call	writeb
	jmp	short savb8
savb9:	mov	al,01ah ;write a ctrl-z as end of file mark
savb10: call	writeb
	cmp	di,boot+080h	;be sure last 128 byte record is written
	mov	al,0
	jnz	savb10
	call	clsfil
resetl: jmp	reset 
;
writeb: mov	byte ptr [di],al	;move char to 128 byte buffer
	inc	di
	cmp	di,boot+0100h
	jnz	wrtx
	push	ax	;if buffer full, write buffer to disk file
	push	si
	mov	dx,offset fcb
	mov	ah,wrtf
	int	021h
	pop	si
	pop	ax
	mov	di,boot+080h	;and clear buffer
wrtx:	ret
;
clsfil: mov	dx,offset fcb	;close disk file
	mov	ah,closf
	int	021h
resetx: mov	al,3
	call	out232	;to return, send ^C to KPC   
	cmp	kpcsw,0
	jne	resety
	mov	al,3
	call	out232	;to return, send ^C to KPC   
	mov	al,3
	jmp	short resetz
resety: mov	al,'X'	;to return, send ^C X to UTU-XT
resetz: call	out232	;to return, send ^C to KPC   
	ret
;
commport:	cmp	kpcsw,0
	je	kpc1
	mov	dx,utucom
	ret
kpc1:	mov	dx,kpccom
	ret
;
commpori:	cmp	kpcsw,0
	je	kpc3
	mov	utucom,dx
	ret
kpc3:	mov	kpccom,dx
	ret
;
baudrate:	cmp	kpcsw,0
	je	kpc5
	mov	ax,utubau
	ret
kpc5:	mov	ax,kpcbau
	ret
;
baudrati:	cmp	kpcsw,0
	je	kpc7
	mov	utubau,ax
	ret
kpc7:	mov	kpcbau,ax
	ret
;
upcomm: mov	dx,1603h
	mov	ah,2
	int	10h
	call	commport
	cmp	incena,0
	jne	upcom0
	inc	dx
	and	dx,1	;ports 0-1
	call	commpori
upcom0: add	dx,'1'
	mov	ax,dx
	mov	ah,14
	int	10h	;display port number
	cmp	kpcsw,0
	je	upcom1
	mov	utumsc,al
	ret
upcom1: mov	kpcmsc,al
	ret
;
upport: push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	call	commport
	call	baudrate
	mov	cl,5
	shl	ax,cl		;set to desired baud rate,
	add	ax,3		;no parity, 1 stop bit, and 8 bit char.
	int	14h		;and 8 bit char.
uppora: call	commport
	mov	ah,25h	;get intr. vector service
	and	dx,dx
	jnz	upporb
	mov	al,ivect1
	mov	dx,rsbas1
	mov	bl,intms1
	jmp	short upporc
upporb:  mov	 al,ivect2
	mov	dx,rsbas2
	mov	bl,intms2
upporc:  mov	 rsbase,dx
	mov	imask,bl
	mov	cx,cs
	mov	ds,cx
	mov	dx,offset rsiisr
	cli
	int	21h
	mov	dx,rsbase
	add	dx,3	;address lcr--line control reg.
	in	al,dx
	and	al,7fh	;reset DLAB (divisor access latch addr. bit)
	out	dx,al
	add	dx,2	;address lsr--line status reg.
	in	al,dx	;reset pending errors
	sub	dx,5	;address rbr--receive buffer reg.
	in	al,dx	;read any pending chars.
	in	al,intmsk
	and	al,imask ;unmask irq4 or irq3
	out	intmsk,al
	mov	dx,rsbase
	inc	dx	;address ier--intr. enable reg.
	mov	al,1	;enable receive data available intr.
	out	dx,al
	add	dx,3	;address mcr--modem control reg.
	in	al,dx
	or	al,9	;enable INS8250 intr.--set dtr and out2
	out	dx,al
	sti		;enable intr.
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
;
upbaud: mov	dx,1605h
	mov	ah,2
	int	10h	;position cursor for baud rate
	cmp	kpcsw,0
	je	upba2g
	mov	di,utubap
	jmp	short upba2h
upba2g: mov	di,kpcbap
upba2h: mov	si,bauptr
	call	baudrate
	cmp	incena,0
	jne	upba2j
	inc	ax
	and	ax,7	;baud rate codes 0-7
	call	baudrati
upba2j: shl	ax,1	;multiply code by 4
	shl	ax,1
	add	si,ax
	mov	cx,4
upba3b: mov	ah,14
	mov	al,[si]
	cmp	al,'$'
	je	upbaud
	int	10h	;display baud rate char.
	movsb
	loop	upba3b
	ret
;
actsc1: cmp	vidmod,7
	jne	acts1a
	push	ds		;save screen0
	mov	cx,0b000h	;monochrome adapter video addr.
	mov	ds,cx
	xor	si,si
	mov	di,offset sc0buf
	mov	cx,2000
	rep movsw
	pop	ds
	xor	bh,bh
	mov	ah,3		;save screen0's cursor
	int	10h
	mov	sc0cur,dx
	push	es		;restore screen1
	mov	cx,0b000h	;monochrome adapter video addr.
	mov	es,cx
	xor	di,di
	mov	si,offset sc1buf
	mov	cx,2000
	rep movsw
	pop	es
	xor	bh,bh
	mov	ah,2		;restore screen1's cursor
	mov	dx,sc1cur
	int	10h
	jmp	short acts1z
acts1a: mov	ax,0501h	;set screen page 1 active
	int	10h
	mov	bh,1		;screen page 1
acts1z: ret
;
actsc0: cmp	vidmod,7
	jne	acts0a
	push	ds		;save screen1
	mov	cx,0b000h	;monochrome adapter video addr.
	mov	ds,cx
	xor	si,si
	mov	di,offset sc1buf
	mov	cx,2000
	rep movsw
	pop	ds
	xor	bh,bh
	mov	ah,3		;save screen1's cursor
	int	10h
	mov	sc1cur,dx
	push	es		;restore screen0
	mov	cx,0b000h	;monochrome adapter video addr.
	mov	es,cx
	xor	di,di
	mov	si,offset sc0buf
	mov	cx,2000
	rep movsw
	pop	es
	xor	bh,bh
	mov	ah,2		;restore screen0's cursor
	mov	dx,sc0cur
	int	10h
	jmp	short acts0z
acts0a: mov	ax,0500h	;set screen page 0 active
	int	10h
	xor	bh,bh		;screen page 0
acts0z: ret
; 
helpdi: push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	call	actsc1
help2:	mov	ah,1
	int	16h
	jz	help2
	xor	ax,ax
	int	16h
	and	al,al
	jnz	help2z
	cmp	ah,comprk      ;comm port key
	je	help3
	cmp	ah,baudk	;baud rate key
	je	help3b
	cmp	ah,exidos
	jne	help22
	mov	ax,0500h	;set screen page 0 active
	int	10h
	pop	ax
	jmp	godos
help22: cmp	ah,kpckey
	jne	help2
	not	kpcsw
	mov	dx,13
	mov	ah,2
	int	10h
	cmp	kpcsw,0
	je	help2a
	mov	si,offset utuid
	jmp	short help2b
help2a: mov	si,offset kpcid
help2b: call	wrtmsg
	mov	dx,1000h
	mov	ah,2
	int	10h
	cmp	kpcsw,0
	je	help2c
	mov	si,offset utumsg
	jmp	short help2d
help2c: mov	si,offset kpcmsg
help2d: call	wrtmsg
	mov	incena,0ffh
	call	upcomm
	call	upbaud
	mov	incena,0
	call	upport
help2e: jmp	short help2
help2z: cmp	al,8	;backspace
	je	helpz
	cmp	al,3	;ctrl C
	je	godos1
	cmp	al,1bh	;escape
	je	godos1
	jmp	help2e
godos1:	mov	ax,0500h	;set screen page 0 active
	int	10h
	pop	ax
	jmp	goedos
help3:	call	upcomm
help3a: call	upport
	jmp	short help2e
help3b: call	upbaud
	jmp	short help3a
helpz:	call	actsc0
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
;
;
wrtmsg: mov	ah,14
	mov	al,[si]
	inc	si
	cmp	al,'$'
	jz	wrtmsz
	int	10h
	jmp	short wrtmsg
wrtmsz: ret
;
onoff:	push	ax	;display on/off at position dx depending on al
	call	pos
	pop	ax
	mov	dx,offset messon
	and	al,al
	jnz	onoff1
	mov	dx,offset messoff
onoff1: mov	ah,9
	int	021h
	ret
;
;gettb is main entry point to get a character from transmit buffer
;     or text disk file.
gettbd: mov	si,point
	mov	byte ptr [si],al
	inc	point
	xor	al,al
	ret
gettb:	mov	al,fflag	;test file flag
	and	al,al
	js	gettbb	;if negative, get byte from disk file
	jz	gettba	;if zero, get byte from transmit buffer
	call	getbkey ;if positive, get byte from transmit buffer to
	jz	gettbx	;   form a disk filename.
	cmp	al,filxmt
	jnz	gettbd	;if not filxmt char, add char to filename
	cmp	point,offset filebuf
	jz	clsfx	;error if no filename
	mov	si,point
	mov	byte ptr [si],0
	mov	si,offset filebuf
	mov	di,offset fcb
	mov	ax,02900h	;verify for proper filename
	int	021h
	and	al,al
	jnz	clsfx	;jump if improper or ambiguous filename
	mov	dx,offset fcb	;before opening file because a few
	mov	ah,openf	;characters will be lost during the
	int	021h		;disk accesses.
	and	al,al
	jnz	clsfx	;jump if file not found
	mov	fcb+32,al	;current record number
	mov	ibp,boot+0100h	;init buffer pointer
	not	fflag	;set file flag negative
	xor	al,al
	ret
gettbb: cmp	ibp,boot+0100h
	jnz	gettbc	;jump if characters still in disk buffer
	mov	dx,offset fcb	;read next 128 bytes from disk
	mov	ah,readf
	int	021h
	and	al,al
	js	clsfx	;?readerr
	mov	ibp,boot+080h
gettbc: mov	si,ibp	;get char from disk buffer
	mov	al,[si]
	inc	ibp
	cmp	al,01ah ;ctrl-z indicates end of file
	jnz	gettbx
clsfx:	xor	al,al
	mov	fflag,al
gettbx: ret
;
;get character from transmit buffer
gettba: mov	al,chrbuf	;check one character buffer first
	and	al,al
	jz	gettba5
	mov	chrbuf,0
gettba2:	cmp	al,0dh
	jz	gettba6
	cmp	autocr,0
	jz	gettba4
	push	ax	;if autocr is on, check the character count
	cmp	al,' '
	mov	al,autocnt
	jnz	gettba3
	sub	al,5
	das
gettba3:	mov	ah,al
	mov	al,charcnt
	add	al,1
	daa
	mov	charcnt,al
	cmp	al,ah
	pop	ax
	jb	gettba4
	mov	chrbuf,0dh	;ok, do an auto CR
gettba4:	and	al,al
	ret
gettba5:	call	getbkey ;get char from transmit buffer
	jz	gettbx
	cmp	al,filxmt
	jnz	gettba2
	mov	fflag,6 	;if filxmt char, set file flag positive
	mov	point,offset filebuf
	xor	al,al
	ret
gettba6:	mov	al,autolf
	mov	chrbuf,al	;LF after CR if autolf on
	mov	charcnt,0
	mov	al,0dh
	and	al,al
	ret
;
getbkey:	mov	si,tbq	;get char from transmit buffer
	cmp	si,tbp
	jz	getbx	;jump if buffer empty
	mov	al,tbuf+[si]	;get char from buffer
	inc	si	;increment buffer pointer
	and	si,tbufsz-1
	mov	tbq,si
	and	al,al
getbx:	ret
;
line:	call	pos	;put a line across screen starting at dx
	mov	cx,scrwd
	mov	ax,0ac4h
	xor	bh,bh
	int	010h
	ret
;
out23c: cmp	al,comch	;if command char (ctrl C),
	je	out23d
	cmp	al,canlch	;cancel line char (ctrl X),
	je	out23d
	cmp	al,passch	;or pass char (ctrl V),
	jne	out232
out23d: push	ax
	mov	al,passch
	call	out232
	pop	ax		;restore char in al
out232: call	setrts
	push	ax	     ;save char
	mov	dx,rsbase
	add	dx,6		;address msr
out23k: in	al,dx
	test	al,10h		;wait for CTS
	jz	out23k
	dec	dx		;address lsr
out23l: in	al,dx		
	test	al,20h		;wait for THRE
	jz	out23l
	pop	ax		;restore char in al
	mov	dx,rsbase    ;output char to rs232 channel 0
	out	dx,al
	ret
;
getrs:	cmp	prtena,0
	jz	getrsx
	cmp	rscnt,0
	jz	getrsy	;jump if buffer is empty
	cli
	mov	bx,rsq
	mov	al,rsbuf+[bx]	;get char from rs232 buffer
	inc	bl	;increment buffer pointer
	mov	rsq,bx
	push	cx
	mov	cx,rscnt
	dec	cx
	mov	rscnt,cx
	pop	cx
	sti
	and	al,al
getrsx: ret
getrsy: cmp	pswch,0ffh
	jz	getrsx
	mov	bufful,0
	call	setrts
	xor	dx,dx
	ret
;
;
setrts: push	dx
	push	ax
	mov	dx,rsbase
	add	dx,4	;addr. mcr
	in	al,dx
	cmp	bufful,0ffh
	je	setrt1
	cmp	rtsena,0ffh
	jnz	setrt1
	or	al,0bh	;set dtr,rts, and out2
setrt0: out	dx,al
	pop	ax
	pop	dx
	ret
setrt1: mov	al,9	;disable rts and leave dtr and out2 set
	jmp	short setrt0
;
staban:	push	ax
	push	bx
	push	dx
	jz	staba0
	shl	bx,1
	mov	dx,stontb+[bx]
	jmp	short staba1
staba0:	shl	bx,1
	mov	dx,stoftb+[bx]
staba1:	push	dx
	sar	bx,1
	mov	dx,scrwd
	add	dx,256*(lines-1)-80
	add	dl,stcol+[bx]
	jae	staba2
	xor	dl,dl
staba2:	call	pos
	pop	dx
	mov	ah,9
	int	21h
	mov	dx,tcur
	call	pos
	pop	dx
	pop	bx
	pop	ax
	ret
;
monxts: push	dx
	push	bx
	push	ax
	mov	dx,rsbase
	add	dx,4	;addr. mcr
	in	al,dx
	mov	bl,al	;save mcr
	add	dx,2	;addr. msr
	in	al,dx
	mov	bh,al	;save msr
	and	bl,1 shl 1
	cmp	rtssav,bl	;rts match rts saved?
	jne	disrts		;if not, display rts change
monxta:	and	bh,1 shl 4
	cmp	ctssav,bh	;cts match cts saved?
	jne	discts		;if not, display cts change
monxtz:	pop	ax
	pop	bx
	pop	dx
	ret
disrts:	mov	rtssav,bl
	and	bl,1 shl 1
	push	bx
	mov	bx,8
	call	staban
	pop	bx
	jmp	monxta
discts:	mov	ctssav,bh
	and	bh,1 shl 4
	push	bx
	mov	bx,9
	call	staban
	pop	bx
	jmp	monxtz
;
rsiisr: cli
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	push	es
	push	ds
	push	cs
	pop	ds
	mov	dx,rsbase
	add	dx,5	;address lsr
	in	al,dx
	test	al,1	;make sure char was received.
	jz	rsiiss
	sub	dx,5	;address rbr
	in	al,dx	;get char.
	mov	bx,rsp	;put character in rs232 buffer
	mov	byte ptr rsbuf+[bx],al
	inc	bl
	mov	rsp,bx
	mov	cx,rscnt
	inc	cx	;increment char count
	mov	rscnt,cx
	cmp	cx,rsnful
	jbe	rsiiss
	mov	bufful,0ffh
	mov	dx,rsbase
	add	dx,4	;address mcr
	mov	al,9	;disable rts and leave dtr and out2 set
	out	dx,al
rsiiss: mov	al,20h	;Non-specific EOI command
	out	int0,al ;clear intr. req.
	pop	ds
	pop	es
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	sti
	iret
;
;
bottom: mov	dx,256*(lines-1) ;put cursor in bottom left position
	mov	ah,2	;put cursor in position dx
	xor	bh,bh
	int	010h
	mov	ax,0601h	;scroll up 1 line
	mov	cx,0
	mov	dx,scrwd
	add	dx,256*(lines-1)-1
	mov	bh,7
	int	010h
	cli
	in	al,intmsk
	or	al,18h	;mask out irq4 and irq3
	out	intmsk,al
	mov	dx,rsbase
	add	dx,3	;address lcr
	in	al,dx
	and	al,7fh	;reset DLAB
	out	dx,al
	sub	dx,2
	xor	al,al
	out	dx,al	;reset ier--rcv data avail intr.
	add	dx,3
	out	dx,al	;reset mcr--disable dtr,rts, and out2
	sti
	ret
;
home:	mov	ax,0600h	;clear screen
	mov	cx,0
	mov	dx,scrwd
	add	dx,256*(lines-1)-1
	mov	bh,7
	int	010h
	xor	dx,dx	;put cursor in top left position
pos:	mov	ah,2	;put cursor in position dx
	xor	bh,bh
	int	010h
	ret
;
blkscr: push	bx
	mov	ax,0600h	;clear screen
	mov	cx,0
	mov	dx,scrwd
	add	dx,256*(lines-1)-1
	mov	bh,7
	int	010h
	pop	bx
	xor	dx,dx	;put cursor in top left position
	mov	ah,2	;put cursor in position dx
	int	010h
	ret
;
outch:	mov	ah,14	;print char to screen
	int	010h
	ret
;
;
getchar:	xor	ah,ah	;get char from keyboard
	int	016h
	cmp	al,060h
	jb	getx
	and	al,05fh ;make it upper case
getx:	ret
;
getkey: mov	ah,1	;char available from keyboard?
	int	016h
	jz	getkxx	;no, jump
	xor	ax,ax	;yes, get char
	int	016h
	and	al,al
	jnz	getkb	;jump if not extended character
	cmp	ah,filxmk
	jnz	getka
	mov	al,filxmt
	jmp	short getkb
getka:	cmp	kpcsw,0
	je	getkb
	cmp	ah,retrck
	jnz	getkb
	mov	al,retrcv
getkb:	mov	ctrlkey,al	;must be a command control key
	mov	keycode,ah	;or a function key
getkx:	and	al,al
getkxx: ret
;
;
mess4	db	'Enter file name',0dh,0ah,'$'
messon	db	' ON$'
messoff db	'OFF$'
mess9	db	'Buffer is empty.',0dh,0ah
	db	'Press a key to return to menu.$'
helpmsg db	'  KANTRONICS KPC    PACTERM Ver 1.03 HELP MENU',0dh,0ah
	db	'   F1   display this help menu',0dh,0ah
	db	'   F2   save holding buffer to file',0dh,0ah
	db	'   F3   toggle KPC / UTU-XT selection',0dh,0ah
	db	'   F5   toggle type ahead / transmit mode',0dh,0ah
	db	'   F6   toggle RTS',0dh,0ah
	db	'   F7   increment communication port number',0dh,0ah
	db	'   F8   increment baud rate',0dh,0ah
	db	'   F9   exit to cmd: mode',0dh,0ah
	db	'   F10  exit to DOS',0dh,0ah
	db	' alt B  buffer control',0dh,0ah
	db	' alt C  clear holding buffer',0dh,0ah
	db	' alt F  file transmit',0dh,0ah
	db	' alt P  enable print',0dh,0ah
	db	' alt R  receive--return to type ahead',0dh,0ah
	db	' alt T  transmit--exit type ahead',0dh,0ah
kpcmsg	db	'                         ',0dh,0ah
	db	'                                   ',0dh,0ah
	db	'                                          ',0dh,0ah
	db	'                    ',0dh,0ah
	db	'                  ',0dh,0ah
	db	0ah
	db	'COM'
kpcmsc	db	'1'
	db	' '
kpcmsb	db	'1200'
	db	' baud used.',0dh,0ah,0ah
	db	'PRESS BACKSPACE TO CONTINUE.'
	db	'$'
utumsg	db	' alt E  return to receive',0dh,0ah
	db	' alt H  shift tone pair frequencies',0dh,0ah
	db	' alt I  invert received signal(rtty/ascii)',0dh,0ah
	db	' alt Sn speed change',0dh,0ah
;	db	' alt X  exit amtor',0dh,0ah
	db	0ah,0ah
	db	'COM'
utumsc	db	'1'
	db	' '
utumsb	db	'1200'
	db	' baud used.',0dh,0ah,0ah
	db	'PRESS BACKSPACE TO CONTINUE.'
	db	'$'
kpcid	db	'KPC   $'
utuid	db	'UTU-XT$'
baudms	db	'$110'
	db	'$150'
	db	' 300'
	db	' 600'
	db	'1200'
	db	'2400'
	db	'4800'
	db	'9600'
	even
bauptr	dw	baudms
kpcbap	dw	kpcmsb
utubap	dw	utumsb
;
stontb	dw	stinit
	dw	stinit
	dw	f1help
	dw	xmtmsg
	dw	xonmsg
	dw	onlmsg
	dw	prtmsg
	dw	bufmsg
	dw	rtsmsg
	dw	ctsmsg
stoftb	dw	stinit
	dw	stinit
	dw	f1help
	dw	rcvmsg
	dw	xofmsg
	dw	oflmsg
	dw	blnk5
	dw	blnk4
	dw	blnk3
	dw	blnk3
stcol	db	0
	db	0
	db	33
	db	43
	db	49
	db	54
	db	60
	db	66
	db	71
	db	75
stinit	db	'                                 F1=HELP'
	db	'   RECV  XON  ONLIN                    $'
f1help	db	'F1=HELP$'
rcvmsg	db	'RECV$'
xmtmsg	db	'XMIT$'
xonmsg	db	'XON $'
onlmsg	db	'ONLIN$'
prtmsg	db	'PRINT$'
bufmsg	db	'BUFF$'
rtsmsg	db	'RTS$'
ctsmsg	db	'CTS$'
xofmsg	db	'XOFF$'
oflmsg	db	'OFLIN$'
blnk5	db	'     $'
blnk4	db	'    $'
blnk3	db	'   $'
;
rsbuf	db	256 dup(?)
pbuf	db	256 dup(?)
filebuf db	16 dup(?)
spbuf	equ	filebuf
tbufsz	equ	1024
tbuf	db	tbufsz dup(?)
sc0buf	dw	2000 dup(0720h)
sc1buf	dw	2000 dup(0720h)
;
hbuf:	db	?
code	ends
	end	begin
